/*
 * logs2html.h -- part of logs2html.mod
 *
 * Written by Fedotov Alexander aka Gray_Angel aka Shmupsik <shurikvz@mail.ru>
 *
 * 2004-2005 year
 */
/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include "src/lang.h"

#define SEP "/"

#undef false
#undef true
typedef enum {false = 0, true} bool;

#ifdef MIN
#  undef MIN
#endif
#define MIN(p,q) ((p < q) ? p : q)

#ifndef isleap
	/* Nonzero if YEAR is a leap year (every 4 years,
	except every 100th isn't, and every 400th is). */
#define isleap(year)	\
	((year) % 4 == 0 && ((year) % 100 != 0 || (year) % 400 == 0))
#endif

#define T_LT "&lt;"
#define T_GT "&gt;"
#define T_BOLDO "<B>"
#define T_BOLDC "</B>"
#define T_UNDERLINEO "<U>"
#define T_UNDERLINEC "</U>"
#define T_SPANC "</SPAN>"
#define T_LINKC "</A>"
 
typedef struct logs2html_data {
	struct logs2html_data *next;
	char channame[81];		/*       */
	char logfilename[128];		/*  ()   (   logfile   ) */
	char outputpath[128];		/*     */
	char mainpagename[61];		/*    */
	char mainpagetitle[256];	/*     */
	char logspagename[61];		/*  ()    */
	char logspagetitle[256];	/*    */
} logs2htmlchan;

typedef enum {ITS_NOTHING, ITS_EMAIL, ITS_LINK, ITS_TRUNKLINK} patternkind;

static int cmd_convertalllogs(struct userrec *u, int idx, char *par);
static int cmd_makemainpage(struct userrec *u, int idx, char *par);
static int getdayofweek(int year, int month, int day);
static FILE *openfile(char *newfilename, const char *mode, bool silent);
static void str_write(FILE *file, char *fstr, ... );
static void makemainpage(logs2htmlchan *ch);
static void convertfile(struct tm *t, logs2htmlchan *ch);
static void writefromexfile(FILE *dst_file, char *exfilename);
static int addchannels(void);
static patternkind whatisit(char *pattern);

